@echo off
setlocal enabledelayedexpansion
pushd %~dp0
chcp 65001
cls
echo =================================================
echo  HoYoverseの画像ダウンロードバッチ (2025/04/12版)
echo =================================================
echo.
echo ▼Genshin Impact
echo 1 : パイモンの絵シリーズ Vol.01～40	632枚	約20MB
echo.
echo.
set /p ANSWER="番号を入力してエンターキーを押してください: "

if %ANSWER%==1 (call :download Genshin_Stamp Genshin_Stamp.txt)
exit

:download
:: ダウンロード先のフォルダが存在しない場合は作成
if not exist "%~dp0%1" (mkdir "%~dp0%1")

:: リストファイルの総行数をカウント
set /a total_lines=0
for /f "usebackq delims=" %%A in ("%2") do (set /a total_lines+=1)

:: リストファイルから1行ずつ読み込み
set /a current_line=0
for /f "usebackq tokens=1,2 delims=," %%A in ("%2") do (
    set /a current_line+=1
    :: 進捗表示
    cls
    echo ダウンロード中: !current_line!/!total_lines! - %%B

    :: 保存予定のファイル名がローカルに存在しない場合のみダウンロード
    if not exist "%~dp0%1\%%B" (

        :: Start-BitsTransferでファイルをダウンロード
        powershell -Command "Start-BitsTransfer -Source '%%A' -Destination '%~dp0%1\%%B'"

        :: ファイルが存在するか確認し、ファイルサイズが0の場合は再ダウンロード
        if exist "%~dp0%1\%%B" (
            for %%I in ("%~dp0%1\%%B") do if %%~zI==0 (
                :: Invoke-WebRequestでファイルを再ダウンロード
                powershell -Command "Invoke-WebRequest -Uri '%%A' -OutFile '%~dp0%1\%%B'"
            )
        )
    )
)
exit /b